Node = Struct.new(:value, :next, :prev)

class List
	def initialize
		@head = @tail = nil
	end
	
	def push(value)
		##Si es un array
	    if value.is_a?(Array)
	      value.each do |val|
	        prev = @tail unless @tail.nil?
	        while prev != @head do
	          prev = prev.next
        	end
    
	        node = Node.new(val, nil, prev)

	        @tail = node if @tail.nil?
	        @head.next = node unless @head.nil?
    
        	@head = node
	      end
	    else  #Si es un único valor
	      prev = @tail unless @tail.nil?
	        while prev != @head do
	          prev = prev.next
	        end
   
	        node = Node.new(value, nil, prev)
	
	        @tail = node if @tail.nil?
	        @head.next = node unless @head.nil?
    
	        @head = node
            end		
	end

	def head
		@head.value unless @head.nil?
	end

	def tail
		@tail.value unless @tail.nil?
	end
	
	def remove_tail
	 	@tail = @tail.next
	end

	def remove_head
		@head = @head.prev
		@head.next = nil
	end

	def to_s
            array = "["
	    next_val = @tail unless @tail.nil?
	      while next_val != nil do
	        array = array + next_val.value.to_s + ", "
	        next_val = next_val.next
        
	        if next_val == nil #For las element
	          array = array.chomp(', ') + "]"
	        end
	      end
	     	 "#{array}"
	end

	def size
		count = 0 
		next_val = @tail unless @tail.nil?
		 while next_val != nil do
			next_val = next_val.next
			count +=1
		 end
		"#{count}"
	end

end
